import processing.video.*;
Capture XYcapture;
Capture Zcapture;
int XYxres = 480/2;
int XYyres = 360/2;
int Zxres = 480/2;
int Zyres = 360/2;
int topMarg = 50;
int botMarg = 50;
int sideMarg = 50;
int sepMarg = 50;
int[] pathX = new int[1];
int[] pathY = new int[1];
int[] pathZ = new int[1];
int pCnt = -1;
boolean captureFlag = false;
boolean dispFlag = false;
int runCnt = 0;

Button disp = new Button();
Button capt = new Button();
Button expt = new Button();
Button qbut = new Button();
PFont font;

void setup() 
{

  size(sideMarg+XYxres+sepMarg+XYxres+sideMarg, topMarg+XYyres+sepMarg+Zyres+botMarg);

  // The name of the capture device is dependent those
  // plugged into the computer. To get a list of the 
  // choices, uncomment the following line 
   println(Capture.list());

  // And to specify the camera, replace "Camera Name" 
  // in the next line with one from Capture.list()

  XYcapture = new Capture(this, XYxres,XYyres, 7);
  Zcapture = new Capture(this, XYxres, XYyres, 7);

  //setup buttons

  capt.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres/10,XYxres/2,Zyres/5);
  disp.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres*2/5,XYxres/2,Zyres/5);
  expt.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres*7/10,XYxres/2,Zyres/5);
  qbut.setPos(sideMarg+XYxres+sepMarg+XYxres+sideMarg-(sideMarg/6+sideMarg/2),topMarg/6,sideMarg/4*2,topMarg/4*2);
  qbut.setAppearance (color(255,255,255), color(145,145,145), color(145,145,145), color(255,255,255), 0, 0);
  
  capt.setText("Start Capture", "Stop Capture");
  disp.setText("Display Path", "Hide Path");
  expt.setText("Export (1)","Exporting . . .");
  qbut.setText("X","X");

  //setup font
  font = loadFont("ArialRoundedMTBold-48.vlw"); //"AlteHaasGrotesk-48.vlw"); 

}

//void captureEvent(Capture thisCapture) {
  //thisCapture.read();
//}



void draw() {
  background(145);
  int XYxpos = sideMarg;
  int XYypos = topMarg;
  int Zxpos = sideMarg;
  int Zypos = topMarg+XYyres+sepMarg;

  //draw buttons
  capt.draw();
  disp.draw();
  expt.draw();
  qbut.draw();
  
  //draw Text
  smooth();
  int titleH = int(min(topMarg,sepMarg)/3);
  textFont(font,titleH);
  textAlign(LEFT);
  fill(255,255,255);
  text("XY - Capture Feed", sideMarg,topMarg/2+titleH/2);
  text("Path Display", sideMarg+XYxres+sepMarg,topMarg/2+titleH/2);
  text("Z - Capture Feed", sideMarg,topMarg+XYyres+sepMarg/2+titleH/2);
  
  //draw video
  if (XYcapture.available()) XYcapture.read();
  if (Zcapture.available()) Zcapture.read();
  image(XYcapture, XYxpos,XYypos);
  image(Zcapture, Zxpos, Zypos);
  loadPixels();
  color[][] XYpixels = new color[XYxres][XYyres];
  color[][] Zpixels = new color[Zxres][Zyres];
  XYpixels = getPixelArr(pixels,XYxpos,XYypos,XYxres,XYyres);
  Zpixels = getPixelArr(pixels,Zxpos,Zypos,Zxres,Zyres);
  
  //draw boxes
  stroke(255,255,255);
  noFill();
  strokeWeight(3);
  strokeJoin(ROUND);
  rect(XYxpos,XYypos,XYxres,XYyres);
  rect(Zxpos,Zypos,Zxres,Zyres);
  rect(XYxpos+XYxres+sepMarg,XYypos,XYxres,XYyres);

  //check to see that pixel arrays are being filled properly
  /* for (int i = 0; i<XYxres; ++i) {
   for (int j = 0; j<XYyres;++j) {
   int xPos = sideMarg+XYxres+sepMarg;
   int yPos = topMarg;
   pixels[(j+yPos)*width+i+xPos] = XYpixels[i][j];
   } 
   }
   updatePixels();*/
  int greenX;
  int greenY;
  int greenZ;

  int[] gXY = new int[2];
  int[] gZ = new int[2];

  gXY = getGreenest(XYpixels);
  gZ = getGreenest(Zpixels);

  //check to see if getGreenest is working
  noFill();
  stroke(#82ED45);
  strokeWeight(2);
  smooth();
  ellipse(XYxpos+gXY[0],XYypos+gXY[1],15,15);
  ellipse(Zxpos+gZ[0],Zypos+gZ[1],15,15);

  //draw path
  greenX = gXY[0];
  greenY = gXY[1];
  greenZ = gZ[0];

  if (captureFlag == true) {
    ++pCnt;
    if (pCnt == 0) {
      pathX[pCnt] = greenX;
      pathY[pCnt] = greenY;
      pathZ[pCnt] = greenZ;
    } 
    else {
      pathX = append(pathX, greenX);
      pathY = append(pathY, greenY);
      pathZ = append(pathZ, greenZ);
    }

  }

  //draw bezier curve representing path
  if (dispFlag == true) {
    beginShape();
    for (int i=0; i<=pCnt;++i){
      curveVertex(sideMarg+XYxres+sepMarg+pathX[i],topMarg+pathY[i]);
    }
    endShape();
  }
  redraw();
  
  //if (frameCount % 5 == 0) {
  // saveFrame(); 
  //}
}



void mousePressed() {
  boolean oldCaptState;
  oldCaptState = captureFlag;
  dispFlag = disp.Toggle(); 
  captureFlag = capt.Toggle();
  boolean exptFlag;
  exptFlag = false;
  exptFlag = expt.Toggle();
  if (exptFlag == true) {
    exportCSV();
    expt.setText("Export ("+str(runCnt+1)+")","Exporting . . .");
    expt.force(false);
    
  }
  if ((oldCaptState == false) && (captureFlag == true)) {
    if (dispFlag == false) {
      dispFlag = true;
      disp.force(dispFlag);
    }
    int[] temp = new int[1];
    temp[0] = 0;
    pathX = temp;
    pathY = temp;
    pathZ = temp;
    pCnt = -1;
    ++runCnt;
  }
 boolean qbutFlag;
qbutFlag = false;
qbutFlag = qbut.Toggle();
if (qbutFlag == true) {
   XYcapture.stop();
    Zcapture.stop();
    exit(); 
}
}


