import processing.core.*; import processing.video.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class _3dCaptureV3 extends PApplet {
Capture XYcapture;
Capture Zcapture;
int XYxres = 480/2;
int XYyres = 360/2;
int Zxres = 480/2;
int Zyres = 360/2;
int topMarg = 50;
int botMarg = 50;
int sideMarg = 50;
int sepMarg = 50;
int[] pathX = new int[1];
int[] pathY = new int[1];
int[] pathZ = new int[1];
int pCnt = -1;
boolean captureFlag = false;
boolean dispFlag = false;
int runCnt = 0;

Button disp = new Button();
Button capt = new Button();
Button expt = new Button();
Button qbut = new Button();
PFont font;

public void setup() 
{

  size(sideMarg+XYxres+sepMarg+XYxres+sideMarg, topMarg+XYyres+sepMarg+Zyres+botMarg);

  // The name of the capture device is dependent those
  // plugged into the computer. To get a list of the 
  // choices, uncomment the following line 
   println(Capture.list());

  // And to specify the camera, replace "Camera Name" 
  // in the next line with one from Capture.list()

  XYcapture = new Capture(this, XYxres,XYyres, 7);
  Zcapture = new Capture(this, XYxres, XYyres, 7);

  //setup buttons

  capt.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres/10,XYxres/2,Zyres/5);
  disp.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres*2/5,XYxres/2,Zyres/5);
  expt.setPos(sideMarg+XYxres+sepMarg+XYxres/4,topMarg+XYyres+sepMarg+Zyres*7/10,XYxres/2,Zyres/5);
  qbut.setPos(sideMarg+XYxres+sepMarg+XYxres+sideMarg-(sideMarg/6+sideMarg/2),topMarg/6,sideMarg/4*2,topMarg/4*2);
  qbut.setAppearance (color(255,255,255), color(145,145,145), color(145,145,145), color(255,255,255), 0, 0);
  
  capt.setText("Start Capture", "Stop Capture");
  disp.setText("Display Path", "Hide Path");
  expt.setText("Export (1)","Exporting . . .");
  qbut.setText("X","X");

  //setup font
  font = loadFont("ArialRoundedMTBold-48.vlw"); //"AlteHaasGrotesk-48.vlw"); 

}

//void captureEvent(Capture thisCapture) {
  //thisCapture.read();
//}



public void draw() {
  background(145);
  int XYxpos = sideMarg;
  int XYypos = topMarg;
  int Zxpos = sideMarg;
  int Zypos = topMarg+XYyres+sepMarg;

  //draw buttons
  capt.draw();
  disp.draw();
  expt.draw();
  qbut.draw();
  
  //draw Text
  smooth();
  int titleH = PApplet.parseInt(min(topMarg,sepMarg)/3);
  textFont(font,titleH);
  textAlign(LEFT);
  fill(255,255,255);
  text("XY - Capture Feed", sideMarg,topMarg/2+titleH/2);
  text("Path Display", sideMarg+XYxres+sepMarg,topMarg/2+titleH/2);
  text("Z - Capture Feed", sideMarg,topMarg+XYyres+sepMarg/2+titleH/2);
  
  //draw video
  if (XYcapture.available()) XYcapture.read();
  if (Zcapture.available()) Zcapture.read();
  image(XYcapture, XYxpos,XYypos);
  image(Zcapture, Zxpos, Zypos);
  loadPixels();
  int[][] XYpixels = new int[XYxres][XYyres];
  int[][] Zpixels = new int[Zxres][Zyres];
  XYpixels = getPixelArr(pixels,XYxpos,XYypos,XYxres,XYyres);
  Zpixels = getPixelArr(pixels,Zxpos,Zypos,Zxres,Zyres);
  
  //draw boxes
  stroke(255,255,255);
  noFill();
  strokeWeight(3);
  strokeJoin(ROUND);
  rect(XYxpos,XYypos,XYxres,XYyres);
  rect(Zxpos,Zypos,Zxres,Zyres);
  rect(XYxpos+XYxres+sepMarg,XYypos,XYxres,XYyres);

  //check to see that pixel arrays are being filled properly
  /* for (int i = 0; i<XYxres; ++i) {
   for (int j = 0; j<XYyres;++j) {
   int xPos = sideMarg+XYxres+sepMarg;
   int yPos = topMarg;
   pixels[(j+yPos)*width+i+xPos] = XYpixels[i][j];
   } 
   }
   updatePixels();*/
  int greenX;
  int greenY;
  int greenZ;

  int[] gXY = new int[2];
  int[] gZ = new int[2];

  gXY = getGreenest(XYpixels);
  gZ = getGreenest(Zpixels);

  //check to see if getGreenest is working
  noFill();
  stroke(0xff82ED45);
  strokeWeight(2);
  smooth();
  ellipse(XYxpos+gXY[0],XYypos+gXY[1],15,15);
  ellipse(Zxpos+gZ[0],Zypos+gZ[1],15,15);

  //draw path
  greenX = gXY[0];
  greenY = gXY[1];
  greenZ = gZ[0];

  if (captureFlag == true) {
    ++pCnt;
    if (pCnt == 0) {
      pathX[pCnt] = greenX;
      pathY[pCnt] = greenY;
      pathZ[pCnt] = greenZ;
    } 
    else {
      pathX = append(pathX, greenX);
      pathY = append(pathY, greenY);
      pathZ = append(pathZ, greenZ);
    }

  }

  //draw bezier curve representing path
  if (dispFlag == true) {
    beginShape();
    for (int i=0; i<=pCnt;++i){
      curveVertex(sideMarg+XYxres+sepMarg+pathX[i],topMarg+pathY[i]);
    }
    endShape();
  }
  redraw();
  
  //if (frameCount % 5 == 0) {
  // saveFrame(); 
  //}
}



public void mousePressed() {
  boolean oldCaptState;
  oldCaptState = captureFlag;
  dispFlag = disp.Toggle(); 
  captureFlag = capt.Toggle();
  boolean exptFlag;
  exptFlag = false;
  exptFlag = expt.Toggle();
  if (exptFlag == true) {
    exportCSV();
    expt.setText("Export ("+str(runCnt+1)+")","Exporting . . .");
    expt.force(false);
    
  }
  if ((oldCaptState == false) && (captureFlag == true)) {
    if (dispFlag == false) {
      dispFlag = true;
      disp.force(dispFlag);
    }
    int[] temp = new int[1];
    temp[0] = 0;
    pathX = temp;
    pathY = temp;
    pathZ = temp;
    pCnt = -1;
    ++runCnt;
  }
 boolean qbutFlag;
qbutFlag = false;
qbutFlag = qbut.Toggle();
if (qbutFlag == true) {
   XYcapture.stop();
    Zcapture.stop();
    exit(); 
}
}



class Button {
  //variables
  int x = 0;
  int y = 0;
  int l = 0;
  int w = 0;
  String rTxt = "Push Me";
  String aTxt = "I'm Running";
  boolean running = false;
  int rFill = color(100,100,100);
  int aFill = color(255,255,255);
  int rStroke = color(255,255,255);
  int aStroke = color(100,100,100);
  float rWeight = 4;
  float aWeight = 6;

  Button() {

  }
  public void setPos (int xPos, int yPos, int xSize, int ySize) {
    x = xPos;
    y = yPos;
    l = xSize;
    w = ySize;
  }
  public void setText (String restingText, String activeText) {
    rTxt = restingText;
    aTxt = activeText;
  }
  public void force (boolean state) {
    if (state==true) {
      running = true;
    } 
    else {
      running = false;
    } 
  }
  public boolean Toggle () {
    if ((mouseX > x && mouseX < x+l) && (mouseY > y && mouseY < y+w)) {
      if (running == true) {
        running = false; 
      }
      else {
        running = true;
      }
    }
    return running;
  }
  public void setAppearance (int rsCol, int rfCol, int asCol, int afCol, float rstW, float astW) {
    rStroke = rsCol;
    rFill = rfCol;
    aStroke = asCol;
    aFill = asCol;
    rWeight = rstW;
    aWeight = astW;
  } 
  public void draw() {
    int currStroke;
    int currFill;
    float currStW;
    String currText;
    //set vars
    if (running == true) {
      currStroke = aStroke;
      currFill = aFill;
      currStW = aWeight; 
      currText = aTxt;
    } 
    else {
      currStroke = rStroke;
      currFill = rFill;
      currStW = rWeight; 
      currText = rTxt;
    }

    //draw box
    smooth();
    strokeWeight(currStW);
    stroke(currStroke);
    if (currStW == 0) noStroke();
    fill(currFill);
    strokeJoin(ROUND);
    rect(x,y,l,w);
    //draw text
    fill(currStroke);
    int fSize;
    if (l>w*1.2f) {
      fSize = PApplet.parseInt(1.5f*l/currText.length());
    } 
    else {
      fSize = PApplet.parseInt(0.70f*l/currText.length());
    }
    textFont(font, fSize);
    textAlign(CENTER);
    smooth();
    text(currText, PApplet.parseInt(x+l*0.5f),PApplet.parseInt(y+w/2+fSize/2));

  }
}

public void exportCSV() {
  if (pCnt > -1) {
  int[][] posArray = new int[pCnt+1][3];
  for (int i = 0; i<= pCnt;++i) {
    //collect data
    posArray[i][0] = pathX[i];
    posArray[i][1] = pathZ[i];
    posArray[i][2] = max(pathY)-pathY[i];
  }
  String[] points = new String[pCnt+1];
  for (int i = 0; i<= pCnt;++i) {
    //write string
    points[i] = str(posArray[i][0]) + ", " + str(posArray[i][1]) + ", " + str(posArray[i][2]);
  }
  
  saveStrings("path_data_"+str(runCnt)+"_y"+year()+"m"+month()+"d"+day()+"h"+hour()+"m"+minute()+"s"+second()+".txt",points);
  
  } else {
   print("no data to export") ;
  }
}

public int[] getGreenest(int[][] pixelArr) {
  int[] avgPos = new int[2];
  float[] greenArr = new float[pixelArr.length*pixelArr[0].length];
  float[] srtdgreenArr = new float[pixelArr.length*pixelArr[0].length];
  //int[] indices1D = new int[pixelArr.length*pixelArr[0].length];
  int topperc = PApplet.parseInt(srtdgreenArr.length*0.0005f);
  int[][]indices2D = new int[topperc][2];

  //determine greeness of each pixel
  for (int i=0;i<pixelArr.length;++i) {
    for (int j=0;j<pixelArr[0].length;++j) {
      float thisRed = red(pixelArr[i][j]);
      float thisGreen = green(pixelArr[i][j]);
      float thisBlue = blue(pixelArr[i][j]);

      greenArr[j*pixelArr.length+i] = thisGreen/4 + thisGreen-thisBlue+thisGreen-thisRed;
    }
  }
  //sort pixels in order of greenness
  srtdgreenArr = reverse(sort(greenArr));
  
  

  for (int i=0;i<topperc;++i) {
    for (int j=0;j<greenArr.length;++j) {
      if (srtdgreenArr[i] == greenArr[j]) {
        indices2D[i][0] = j % pixelArr.length;
        indices2D[i][1] = (j-indices2D[i][0])/pixelArr.length;
        break;
      }
    } 
  }
  //avergae top 2%
  
  avgPos[0] = 0;
  avgPos[1] = 0;
  for (int i=0;i<topperc;++i){
    avgPos[0] = avgPos[0]+indices2D[i][0];
    avgPos[1] = avgPos[1]+indices2D[i][1];
  }
  avgPos[0] = avgPos[0]/topperc;
  avgPos[1] = avgPos[1]/topperc;
  return avgPos; 
}

public int[][] getPixelArr(int[] allPixels, int xPos, int yPos, int xRes, int yRes) {
  int[][] pixelArr = new int[xRes][yRes];

  for (int i = 0; i<xRes; ++i) {
    for (int j = 0; j<yRes;++j) {
      pixelArr[i][j] = allPixels[(j+yPos)*width+i+xPos];
    } 
  }
  return pixelArr;
}

public void keyPressed() {
  if (key == 's') {
    if (captureFlag == false) {
      captureFlag = true;
      dispFlag = true;
      int[] temp = new int[1];
      temp[0] = 0;
      pathX = temp;
      pathY = temp;
      pathZ = temp;
      pCnt = -1;
      ++runCnt;
    } 
    else {
      captureFlag = false;
    }
  } 
  else if (key == 'c') {
    dispFlag = false;
  } 
  else if (key == 'e') {
    exportCSV(); 
  }
  else if (key == 'x') {
    //XYcapture.settings(); 
    XYcapture = new Capture(this, XYxres,XYyres, 7);
  }
  else if (key == 'z') {
    //Zcapture.settings(); 
    Zcapture = new Capture(this, XYxres,XYyres, 7);
  }
  else if (key == 'q') {
    XYcapture.stop();
    Zcapture.stop();
    exit(); 
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "_3dCaptureV3" });  }}